function [V,H,R,c,alpha,u,k] = GMRES_verze1(A,b,u0,epsilon)

n = length(u0);

r0 = A*u0-b;
rho0 = norm(r0);

v0 = r0/rho0;

V = zeros(n,n);
V(:,1) = v0;

H = zeros(n+1,n);

for k=0:n-1
    
    w = A*V(:,k+1);
    
    vHat = w;
    for l=0:k
        beta = V(:,l+1)'*w;
        H(l+1,k+1) = beta;
        vHat = vHat - beta*V(:,l+1);
    end
    beta = norm(vHat);
    H(k+2,k+1) = beta;
    
    if beta < 1e-8

        R = H;
        c = rho0 * [1;zeros(k+1,1)];
        for l=0:k
            denom = sqrt(R(l+1,l+1)^2+R(l+2,l+1)^2);
            a = R(l+1,l+1)/denom;
            b = R(l+2,l+1)/denom;
            Gl = [a , b ; -b , a];
            R(l+1:l+2,:) = Gl * R(l+1:l+2,:);
            c(l+1:l+2) = Gl * c(l+1:l+2);
        end    
        
        break;
    end
    
    V(:,k+2) = vHat/beta;
    
    R = H;
    c = rho0 * [1;zeros(k+1,1)];
    for l=0:k
        denom = sqrt(R(l+1,l+1)^2+R(l+2,l+1)^2);
        a = R(l+1,l+1)/denom;
        b = R(l+2,l+1)/denom;
        Gl = [a , b ; -b , a];
        R(l+1:l+2,:) = Gl * R(l+1:l+2,:);
        c(l+1:l+2) = Gl * c(l+1:l+2);
    end    
    
    rho = abs(c(k+2));
    
    if rho/rho0 < epsilon
        break;
    end
    
end

alpha = R(1:k+1,1:k+1)\c(1:k+1);

u = u0 - V(:,1:k+1)*alpha;

k = k+1;
