function u = GaussElimination(A,b)

n = size(A,1);
u = zeros(n,1);

% dopredna eliminace
for i=1:n-1
    pivot = A(i,i);
    for j=i+1:n
        c = A(j,i)/pivot;
        A(j,i:n) = A(j,i:n) - c*A(i,i:n);
        b(j) = b(j) - c*b(i);
    end
end

% zpetna substituce
for i=n:-1:1
    u(i) = b(i)/A(i,i);
    b(1:i-1) = b(1:i-1) - A(1:i-1,i)*u(i);
end
