function u = IncompleteGaussElimination(A,b)

n = size(A,1);
u = zeros(n,1);

prec = 1e-8;

% dopredna eliminace
for i=1:n-1
    pivot = A(i,i);
    for j=i+1:n     % radeji vyuzit find(A(:,i))
        if abs(A(j,i)) < prec
            continue;
        end
        c = A(j,i)/pivot;
        for k=i:n
            if abs(A(j,k)) < prec
                continue;
            end
            A(j,k) = A(j,k) - c*A(i,k);
        end
        b(j) = b(j) - c*b(i);
    end
end

% zpetna substituce
for i=n:-1:1
    u(i) = b(i)/A(i,i);
    for j=1:n-1   % radeji vyuzit find(A(:,i))
        if abs(A(j,i)) < prec
            continue;
        end
        b(j) = b(j) - A(j,i)*u(i);
    end
end
