function [x,e,ID,IN] = discret(k,l,m,n,h)

% [x,e,ID,IN] = discret(k,l,m,n,h)
%          Funkce diskretizuje ctverec <k,l> x <m,n> s krokem h.
%          x je vektor uzlovych souranic.
%          e jsou trojuhelnikove elementy = trojice indexu uzlu.
%          I1 je Dirichletova cast hranice, tj. indexy uzlu Gamma_1,
%          coz je spodni a horni strana ctverce.
%          I2 je Neumannova cast hranice, tj. indexy uzlu Gamma_2,
%          coz je leva a prava strana ctverce.

x1 = k:h:l;
x2 = m:h:n;

nx1 = max(size(x1));
nx2 = max(size(x2));

x = [];
e = [];
ID = [];
IN = [];
index = 1;

% seznam uzlu a elementu
for i=1:nx1
    for j=1:nx2
        x = [x [x1(i);x2(j)]];
        
        if i<nx1 & j<nx2
            e = [ e , [index ; index+nx2+1 ; index+1] , [index ; index+nx2 ; index+nx2+1 ] ];
        end
        
        if i==1 || i==nx1 || j==1 || j==nx2
            ID = [ID;index];
        end
        
%         if j==1 | j==nx2
%             IN = [ IN , [index;index+1] ];
%         end
        
        index = index + 1;
    end
end
