function [A,b] = mkp(x,f)

n = length(x);

A = zeros(n,n);
b = zeros(n,1);

for i=1:n
    if i>1
        h = x(i)-x(i-1);
        A(i,i-1) = -1/h;
        A(i,i) = 1/h;
        xmid = 0.5*(x(i-1)+x(i));
        b(i) = 0.5 * feval(f,xmid) * h;
    end
    if i<n
        h = x(i+1)-x(i);
        A(i,i) = A(i,i) + 1/h;
        A(i,i+1) = -1/h;
        xmid = 0.5*(x(i)+x(i+1));
        b(i) = b(i) + 0.5 * feval(f,xmid) * h;
    end    
end

% nulovy Dirichlet
A(1,2:n) = 0;
b(1) = 0;
A(n,1:n-1) = 0;
b(n) = 0;
