function [u,k] = predpod_sdruz_grad(A,b,applyInvC_func,u0,epsilon)

u = u0;

r = b - A*u;
norm_r0 = norm(r);
norm_r = norm_r0;

z = feval(str2func(applyInvC_func),r);

p = z;

k = 0;


while norm_r/norm_r0 > epsilon
    
    Ap = A*p;
    pAp = p'*Ap;
    
    alpha = (r'*z) / pAp;
    
    u = u + alpha*p;
    
    r_prev = r;
    r = r - alpha*Ap;
    norm_r = norm(r)
    
    z_prev = z;
    z = feval(str2func(applyInvC_func),r);
    
    beta = (r'*z) / (r_prev'*z_prev);
    
    p = z + beta*p;
    
    k = k+1;
    
end
