function [xnew,elemNodesnew,nodalIDnew,edgesnew,elemEdgesnew,nodalExtension,elemExtension,CRnodalExtension,CRnodalRestriction,edgeIDnew] = refine_uniform_L1tri(x,nodalID,edges,elemEdges,edgeID)

% [xnew,elemNodesnew,nodalIDnew,edgesnew,elemEdgesnew,nodalExtension,elemExtension,CRnodalExtension,CRnodalRestriction,edgeIDnew] = refine_uniform_L1tri(x,nodalnodalID,edges,elemEdges,edgeID)

xnew = x;
nodalIDnew = nodalID;
elemNodesnew = [];

edgesnew = [];
elemEdgesnew = [];
edgeIDnew = [];

n = size(x,2);
nnew = n;
nelems = size(elemEdges,2);
nedges = size(edges,2);
nedgesnew = 0;

% edge refinement
for i=1:nedges
    edgei = edges(:,i);
    
    x1 = x(:,edgei(1));
    x2 = x(:,edgei(2));
    
    xnew = [ xnew , 0.5*(x1+x2) ];
    nnew = nnew+1;
    edgesnew = [ edgesnew , [edgei(1);nnew] , [nnew;edgei(2)] ];
    nedgesnew = nedgesnew + 2;
    
    if in(edgeID,i)
        edgeIDnew = [ edgeIDnew ; nedgesnew-1 ; nedgesnew ];
        if (in(nodalID,edgei(1)) & in(nodalID,edgei(2)))
            nodalIDnew = [ nodalIDnew ; nnew ];
        end
    end
end
    
elemExtension = sparse(4*nelems,nelems);
CRnodalExtension = sparse(2*nedges+3*nelems,nedges);
CRnodalRestriction = sparse(nedges,2*nedges+3*nelems);
edgeToNrNewElems = zeros(nedges,1);

% element refinement
for i=1:nelems 
    edge1Idx = elemEdges(1,i);
    edge2Idx = elemEdges(2,i);
    edge3Idx = elemEdges(3,i);
    
    edge11Idx = 2*abs(edge1Idx)-1;
    edge12Idx = 2*abs(edge1Idx);
    edge21Idx = 2*abs(edge2Idx)-1;
    edge22Idx = 2*abs(edge2Idx);
    edge31Idx = 2*abs(edge3Idx)-1;
    edge32Idx = 2*abs(edge3Idx);
    
    edge11 = edgesnew(:,edge11Idx);
    edge12 = edgesnew(:,edge12Idx);
    edge21 = edgesnew(:,edge21Idx);
    edge22 = edgesnew(:,edge22Idx);
    edge31 = edgesnew(:,edge31Idx);
    edge32 = edgesnew(:,edge32Idx);
    
    if (edge1Idx > 0)
        node1Idx = edge11(1);
        node2Idx = edge11(2);
        node3Idx = edge12(2);
    else
        node1Idx = edge12(2);
        node2Idx = edge11(2);
        node3Idx = edge11(1);
    end
    if (edge2Idx > 0)
        node4Idx = edge22(1);
        node5Idx = edge22(2);
    else
        node4Idx = edge21(2);
        node5Idx = edge21(1);
    end
    node6Idx = edge32(1);
    
    if (edge1Idx > 0)
        edge11Idx = sign(edge1Idx)*edge11Idx;
        edge12Idx = sign(edge1Idx)*edge12Idx;
    else
        tmp = edge11Idx;
        edge11Idx = sign(edge1Idx)*edge12Idx;
        edge12Idx = sign(edge1Idx)*tmp;
    end
    if (edge2Idx > 0)
        edge21Idx = sign(edge2Idx)*edge21Idx;
        edge22Idx = sign(edge2Idx)*edge22Idx;
    else
        tmp = edge21Idx;
        edge21Idx = sign(edge2Idx)*edge22Idx;
        edge22Idx = sign(edge2Idx)*tmp;
    end
    if (edge3Idx > 0)
        edge31Idx = sign(edge3Idx)*edge31Idx;
        edge32Idx = sign(edge3Idx)*edge32Idx;
    else
        tmp = edge31Idx;
        edge31Idx = sign(edge3Idx)*edge32Idx;
        edge32Idx = sign(edge3Idx)*tmp;
    end
    
    edge4Idx = nedgesnew+1;
    edge5Idx = nedgesnew+2;
    edge6Idx = nedgesnew+3;
    edge4 = [node2Idx;node4Idx];
    edge5 = [node4Idx;node6Idx];
    edge6 = [node6Idx;node2Idx];
    
    edgesnew = [ edgesnew , edge4 , edge5 , edge6 ];
    nedgesnew = nedgesnew+3;
    
    elemNodesnew = [ elemNodesnew , [node2Idx;node4Idx;node6Idx] , [node1Idx;node2Idx;node6Idx] , [node2Idx;node3Idx;node4Idx] , [node4Idx;node5Idx;node6Idx] ];
    elemEdgesnew = [ elemEdgesnew , [edge4Idx;edge5Idx;edge6Idx] , [edge11Idx;-edge6Idx;edge32Idx] , [edge12Idx;edge21Idx;-edge4Idx] , [edge22Idx;edge31Idx;-edge5Idx] ];
    
    elemExtension(4*(i-1)+1,i) = 1;
    elemExtension(4*(i-1)+2,i) = 1;
    elemExtension(4*(i-1)+3,i) = 1;
    elemExtension(4*i,i) = 1;

    % Crouzeix-Raviart extension (prolongation) operator
    node1 = xnew(:,node1Idx);
    node2 = xnew(:,node2Idx);
    node3 = xnew(:,node3Idx);
    node4 = xnew(:,node4Idx);
    node5 = xnew(:,node5Idx);
    node6 = xnew(:,node6Idx);
    MH = [node2',1;node4',1;node6',1];
    invMH = inv(MH);
    M1h = 0.5 * [0.5*(node1'+node2'),1;0.5*(node2'+node3'),1;0.5*(node3'+node4'),1;0.5*(node4'+node5'),1;0.5*(node5'+node6'),1;0.5*(node6'+node1'),1];
    M2h = [0.5*(node2'+node4'),1;0.5*(node4'+node6'),1;0.5*(node6'+node2'),1];
    M1hH = M1h*invMH;
    M2hH = M2h*invMH;
    indices1h = abs([edge11Idx,edge12Idx,edge21Idx,edge22Idx,edge31Idx,edge32Idx]);
    indices2h = abs([edge4Idx,edge5Idx,edge6Idx]);
    indicesH = abs([edge1Idx,edge2Idx,edge3Idx]);
    CRnodalExtension(indices1h,indicesH) = CRnodalExtension(indices1h,indicesH) + M1hH;
    CRnodalExtension(indices2h,indicesH) = M2hH;

    % Crouzeix-Raviart restriction operator
    edgeToNrNewElems(abs(elemEdges(:,i))) = edgeToNrNewElems(abs(elemEdges(:,i))) + 3;
    CRnodalRestriction(abs(edge1Idx),[indices1h,indices2h]) = CRnodalRestriction(abs(edge1Idx),[indices1h,indices2h]) + [1 1 -1 0 0 -1 2 -1 2];
    CRnodalRestriction(abs(edge2Idx),[indices1h,indices2h]) = CRnodalRestriction(abs(edge2Idx),[indices1h,indices2h]) + [0 -1 1 1 -1 0 2 2 -1];
    CRnodalRestriction(abs(edge3Idx),[indices1h,indices2h]) = CRnodalRestriction(abs(edge3Idx),[indices1h,indices2h]) + [-1 0 0 -1 1 1 -1 2 2];
end

for i=1:nedges
    CRnodalRestriction(i,:) = (1/edgeToNrNewElems(i)) * CRnodalRestriction(i,:);
end
    
% nodal-extension operator
nodalExtension = sparse(nnew,n);
for i=1:n
%    if (~in(nodalID,i))
        nodalExtension(i,i) = 1;
        %    end
end
for i=1:nedges
%    if (~in(nodalIDnew,edges(1,i)))
        nodalExtension(n+i,edges(1,i)) = 0.5;
        %    end
%    if (~in(nodalIDnew,edges(2,i)))
        nodalExtension(n+i,edges(2,i)) = 0.5;
        %   end
end
