function [u,k] = sdruz_grad(A,b,u0,epsilon)

u = u0;

r = b - A*u;
norm_r0 = norm(r);
norm_r = norm_r0;

p = r;

k = 0;


while norm_r/norm_r0 > epsilon
    
    Ap = A*p;
    pAp = p'*Ap;
    alpha = (r'*p) / pAp;
    u = u + alpha*p;
    r = r - alpha*Ap;
    norm_r = norm(r);
    beta = - (r'*Ap) / pAp;
    p = r + beta*p;
    
    k = k+1;
    
end
